import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataSnowflakeCurrentAccountConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/current_account#id DataSnowflakeCurrentAccount#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/current_account snowflake_current_account}
*/
export declare class DataSnowflakeCurrentAccount extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "snowflake_current_account";
    /**
    * Create a new {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/current_account snowflake_current_account} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataSnowflakeCurrentAccountConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataSnowflakeCurrentAccountConfig);
    get account(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get region(): string;
    get url(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
