import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataSnowflakeGrantsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#id DataSnowflakeGrants#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * future_grants_in block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#future_grants_in DataSnowflakeGrants#future_grants_in}
    */
    readonly futureGrantsIn?: DataSnowflakeGrantsFutureGrantsIn;
    /**
    * future_grants_to block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#future_grants_to DataSnowflakeGrants#future_grants_to}
    */
    readonly futureGrantsTo?: DataSnowflakeGrantsFutureGrantsTo;
    /**
    * grants_of block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#grants_of DataSnowflakeGrants#grants_of}
    */
    readonly grantsOf?: DataSnowflakeGrantsGrantsOf;
    /**
    * grants_on block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#grants_on DataSnowflakeGrants#grants_on}
    */
    readonly grantsOn?: DataSnowflakeGrantsGrantsOn;
    /**
    * grants_to block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#grants_to DataSnowflakeGrants#grants_to}
    */
    readonly grantsTo?: DataSnowflakeGrantsGrantsTo;
}
export interface DataSnowflakeGrantsGrants {
}
export declare function dataSnowflakeGrantsGrantsToTerraform(struct?: DataSnowflakeGrantsGrants): any;
export declare class DataSnowflakeGrantsGrantsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataSnowflakeGrantsGrants | undefined;
    set internalValue(value: DataSnowflakeGrantsGrants | undefined);
    get createdOn(): string;
    get grantOption(): cdktf.IResolvable;
    get grantedBy(): string;
    get grantedOn(): string;
    get grantedTo(): string;
    get granteeName(): string;
    get name(): string;
    get privilege(): string;
}
export declare class DataSnowflakeGrantsGrantsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataSnowflakeGrantsGrantsOutputReference;
}
export interface DataSnowflakeGrantsFutureGrantsInSchema {
    /**
    * The database in which the scehma resides. Optional when querying a schema in the current database.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#database_name DataSnowflakeGrants#database_name}
    */
    readonly databaseName?: string;
    /**
    * The name of the schema to list all privileges of new (ie. future) objects granted to
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#schema_name DataSnowflakeGrants#schema_name}
    */
    readonly schemaName: string;
}
export declare function dataSnowflakeGrantsFutureGrantsInSchemaToTerraform(struct?: DataSnowflakeGrantsFutureGrantsInSchemaOutputReference | DataSnowflakeGrantsFutureGrantsInSchema): any;
export declare class DataSnowflakeGrantsFutureGrantsInSchemaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataSnowflakeGrantsFutureGrantsInSchema | undefined;
    set internalValue(value: DataSnowflakeGrantsFutureGrantsInSchema | undefined);
    private _databaseName?;
    get databaseName(): string;
    set databaseName(value: string);
    resetDatabaseName(): void;
    get databaseNameInput(): string | undefined;
    private _schemaName?;
    get schemaName(): string;
    set schemaName(value: string);
    get schemaNameInput(): string | undefined;
}
export interface DataSnowflakeGrantsFutureGrantsIn {
    /**
    * Lists all privileges on new (i.e. future) objects of a specified type in the database granted to a role.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#database DataSnowflakeGrants#database}
    */
    readonly database?: string;
    /**
    * schema block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#schema DataSnowflakeGrants#schema}
    */
    readonly schema?: DataSnowflakeGrantsFutureGrantsInSchema;
}
export declare function dataSnowflakeGrantsFutureGrantsInToTerraform(struct?: DataSnowflakeGrantsFutureGrantsInOutputReference | DataSnowflakeGrantsFutureGrantsIn): any;
export declare class DataSnowflakeGrantsFutureGrantsInOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataSnowflakeGrantsFutureGrantsIn | undefined;
    set internalValue(value: DataSnowflakeGrantsFutureGrantsIn | undefined);
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _schema;
    get schema(): DataSnowflakeGrantsFutureGrantsInSchemaOutputReference;
    putSchema(value: DataSnowflakeGrantsFutureGrantsInSchema): void;
    resetSchema(): void;
    get schemaInput(): DataSnowflakeGrantsFutureGrantsInSchema | undefined;
}
export interface DataSnowflakeGrantsFutureGrantsTo {
    /**
    * Lists all privileges on new (i.e. future) objects of a specified type in a database or schema granted to the role.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#role DataSnowflakeGrants#role}
    */
    readonly role: string;
}
export declare function dataSnowflakeGrantsFutureGrantsToToTerraform(struct?: DataSnowflakeGrantsFutureGrantsToOutputReference | DataSnowflakeGrantsFutureGrantsTo): any;
export declare class DataSnowflakeGrantsFutureGrantsToOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataSnowflakeGrantsFutureGrantsTo | undefined;
    set internalValue(value: DataSnowflakeGrantsFutureGrantsTo | undefined);
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
}
export interface DataSnowflakeGrantsGrantsOf {
    /**
    * Lists all users and roles to which the role has been granted
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#role DataSnowflakeGrants#role}
    */
    readonly role?: string;
    /**
    * Lists all the accounts for the share and indicates the accounts that are using the share.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#share DataSnowflakeGrants#share}
    */
    readonly share?: string;
}
export declare function dataSnowflakeGrantsGrantsOfToTerraform(struct?: DataSnowflakeGrantsGrantsOfOutputReference | DataSnowflakeGrantsGrantsOf): any;
export declare class DataSnowflakeGrantsGrantsOfOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataSnowflakeGrantsGrantsOf | undefined;
    set internalValue(value: DataSnowflakeGrantsGrantsOf | undefined);
    private _role?;
    get role(): string;
    set role(value: string);
    resetRole(): void;
    get roleInput(): string | undefined;
    private _share?;
    get share(): string;
    set share(value: string);
    resetShare(): void;
    get shareInput(): string | undefined;
}
export interface DataSnowflakeGrantsGrantsOn {
    /**
    * Object hierarchy to list privileges on. The only valid value is: ACCOUNT. Setting this attribute lists all the account-level (i.e. global) privileges that have been granted to roles.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#account DataSnowflakeGrants#account}
    */
    readonly account?: boolean | cdktf.IResolvable;
    /**
    * Name of object to list privileges on
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#object_name DataSnowflakeGrants#object_name}
    */
    readonly objectName?: string;
    /**
    * Type of object to list privileges on.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#object_type DataSnowflakeGrants#object_type}
    */
    readonly objectType?: string;
}
export declare function dataSnowflakeGrantsGrantsOnToTerraform(struct?: DataSnowflakeGrantsGrantsOnOutputReference | DataSnowflakeGrantsGrantsOn): any;
export declare class DataSnowflakeGrantsGrantsOnOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataSnowflakeGrantsGrantsOn | undefined;
    set internalValue(value: DataSnowflakeGrantsGrantsOn | undefined);
    private _account?;
    get account(): boolean | cdktf.IResolvable;
    set account(value: boolean | cdktf.IResolvable);
    resetAccount(): void;
    get accountInput(): boolean | cdktf.IResolvable | undefined;
    private _objectName?;
    get objectName(): string;
    set objectName(value: string);
    resetObjectName(): void;
    get objectNameInput(): string | undefined;
    private _objectType?;
    get objectType(): string;
    set objectType(value: string);
    resetObjectType(): void;
    get objectTypeInput(): string | undefined;
}
export interface DataSnowflakeGrantsGrantsTo {
    /**
    * Lists all privileges and roles granted to the role
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#role DataSnowflakeGrants#role}
    */
    readonly role?: string;
    /**
    * Lists all the privileges granted to the share
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#share DataSnowflakeGrants#share}
    */
    readonly share?: string;
    /**
    * Lists all the roles granted to the user. Note that the PUBLIC role, which is automatically available to every user, is not listed
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants#user DataSnowflakeGrants#user}
    */
    readonly user?: string;
}
export declare function dataSnowflakeGrantsGrantsToToTerraform(struct?: DataSnowflakeGrantsGrantsToOutputReference | DataSnowflakeGrantsGrantsTo): any;
export declare class DataSnowflakeGrantsGrantsToOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataSnowflakeGrantsGrantsTo | undefined;
    set internalValue(value: DataSnowflakeGrantsGrantsTo | undefined);
    private _role?;
    get role(): string;
    set role(value: string);
    resetRole(): void;
    get roleInput(): string | undefined;
    private _share?;
    get share(): string;
    set share(value: string);
    resetShare(): void;
    get shareInput(): string | undefined;
    private _user?;
    get user(): string;
    set user(value: string);
    resetUser(): void;
    get userInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants snowflake_grants}
*/
export declare class DataSnowflakeGrants extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "snowflake_grants";
    /**
    * Create a new {@link https://registry.terraform.io/providers/snowflake-labs/snowflake/0.62.0/docs/data-sources/grants snowflake_grants} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataSnowflakeGrantsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataSnowflakeGrantsConfig);
    private _grants;
    get grants(): DataSnowflakeGrantsGrantsList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _futureGrantsIn;
    get futureGrantsIn(): DataSnowflakeGrantsFutureGrantsInOutputReference;
    putFutureGrantsIn(value: DataSnowflakeGrantsFutureGrantsIn): void;
    resetFutureGrantsIn(): void;
    get futureGrantsInInput(): DataSnowflakeGrantsFutureGrantsIn | undefined;
    private _futureGrantsTo;
    get futureGrantsTo(): DataSnowflakeGrantsFutureGrantsToOutputReference;
    putFutureGrantsTo(value: DataSnowflakeGrantsFutureGrantsTo): void;
    resetFutureGrantsTo(): void;
    get futureGrantsToInput(): DataSnowflakeGrantsFutureGrantsTo | undefined;
    private _grantsOf;
    get grantsOf(): DataSnowflakeGrantsGrantsOfOutputReference;
    putGrantsOf(value: DataSnowflakeGrantsGrantsOf): void;
    resetGrantsOf(): void;
    get grantsOfInput(): DataSnowflakeGrantsGrantsOf | undefined;
    private _grantsOn;
    get grantsOn(): DataSnowflakeGrantsGrantsOnOutputReference;
    putGrantsOn(value: DataSnowflakeGrantsGrantsOn): void;
    resetGrantsOn(): void;
    get grantsOnInput(): DataSnowflakeGrantsGrantsOn | undefined;
    private _grantsTo;
    get grantsTo(): DataSnowflakeGrantsGrantsToOutputReference;
    putGrantsTo(value: DataSnowflakeGrantsGrantsTo): void;
    resetGrantsTo(): void;
    get grantsToInput(): DataSnowflakeGrantsGrantsTo | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
